%
% Lemmas
%
\section{Substitution}

Substitution is the primary lemma needed for proving the type
preservation theorem~\ref{theorem:preservation}.
%
\iftechreport
\else
Program evaluation uses the evaluation contexts shown in Figure~\ref{figure:evaluation-contexts},
which define left-to-right evaluation of the outermost atoms in an expression.
%
\makefigure{figure:evaluation-contexts}{Evaluation Contexts}{%
$$
\begin{array}{rcl}
A & ::= & [ ]\\
  &  |  & \mathop{\unop} A\\
  &  |  & A \mathrel{\binop} a\\
  &  |  & h \mathrel{\binop} A\\
\\
S & ::= & \tailsysmigrate{j}{A}{a_o}{a_{\ms{fun}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailsysmigrate{j}{h_p}{A}{a_{\ms{fun}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailsysmigrate{j}{h_p}{h_o}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
% JDS: Not enough space in the POPL paper for the ellipses notation here.
  &  |  & {\setindex{k} \tailsysmigrate{j}{h_p}{h_o}{h_{\ms{fun}}}{\lvec{h\subi}{\polybase}{i - 1}, A, \lvec{a\subi}{i + 1}{\varbound}}}\\
  &  |  & \tailatomic{A}{a_{\ms{const}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomic{\atomfun{v}}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomic{\atomfun{v}}{h_{\ms{const}}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}\\
  &  |  & \tailatomicrollback{A}{a_\ms{const}}\\
  &  |  & \tailatomicrollback{h_{\ms{level}}}{A}\\
  &  |  & \tailatomiccommit{A}{a_\ms{fun}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomiccommit{h_{\ms{level}}}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomiccommit{h_{\ms{level}}}{\atomfun{v}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}\\
\\
L & ::= & \alloctuple{\tupleclass}{t}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}\\
  &  |  & \allocunion{t}{\tyvar}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}{i}\\
  &  |  & \allocarray{t}{A}{a_\ms{init}}\\
  &  |  & \allocarray{t}{h_\ms{size}}{A}\\
  &  |  & \allocmalloc{t}{A}\\
\\
E & ::= & \letatom{v}{t}{A}{e}\\
  &  |  & \tailcall{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailcall{\atomfun{v}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{n - 1}}\\
  &  |  & \specialcall{S}\\
  &  |  & \matchstmt{A}{\lvec{\matchcase{s\subi}{e\subi}}{\polybase}{\varbound}}\\
  &  |  & \letalloc{v}{L}{e}\\
  &  |  & \letsubscript{v}{t}{A}{a_2}{e}\\
  &  |  & \letsubscript{v}{t}{h}{A}{e}\\
  &  |  & \setsubscript{A}{a_2}{t}{a_3}{e}\\
  &  |  & \setsubscript{v}{A}{t}{a_3}{e}\\
  &  |  & \setsubscript{v}{h}{t}{A}{e}\\
  &  |  & \setglobal{\xlabel}{t}{A}{e}
\end{array}
$$
}
\fi
%
The goal in this section is to show that if an expression $E[a_1] : t$ is well-typed for some value
$a_1 : u$, then $E[a_2] : t$ for any other atom $a_2 : u$.

We prove this in two parts.
First, we show that if $E[a]$ is well-typed, then $a : t_a$ for
\emph{some} type $t_a$.
Second, we use this to prove the substitution lemma.

\iftechreport
\else

The following four lemmas spell out a set of typing properties that assert,
essentially, that every subterm of a well-typed program is also well-typed.  In all cases the
argument is by structural induction on the evaluation context.

\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Well-formed type judgments for atom contexts.
%
\begin{lemma}
\thmtitle\atomtyping{lemma:atom-typing}{Atom typing}
If $\withenv{\genv_r}{A[a] : t_r}$, then there is a type $t_a$ such that
$\withenv{\genv_r}{a : t_a}$.
\end{lemma}

\iftechreport
\begin{proof}
\setgenvtypehat
\setgenvname{\genvorig_r}
We prove this by structural induction on $A$.

%
% A = []
%
\begin{proofcase}{Trivial context}
Suppose $A = [ ]$.  Then $A[a] = a$ and we have the following judgment.

$$\withenv{\genv}{a : t_r}.$$
\end{proofcase}

%
% A = unop A
%
\begin{proofcase}{Unary operators}
\setatomname{A'[a]}
Suppose $A[a] = \mathop{\unop} A'[a]$.  The type judgment must use the \refmath{Ty-AtomUnop} rule.

$$\tyatomunop$$

Using induction on the premise $\withgenv \atomname : \unoptypearg{\unop}$ we infer that there is
some type $t_a$ for which

$$\withgenv a : t_a.$$
\end{proofcase}

%
% A = A binop a
% A = h binop A
%
\begin{proofcase}{Binary operators}
\setatomnameone{A'[a]}
\setatomnametwo{a'}
Suppose $A[a] = \atomnameone \mathrel{\binop} a'$.  the type judgment must use the
\refmath{Ty-AtomBinop} rule.

$$\tyatombinop$$

Using induction on the premise $\withgenv \atomnameone : \binoptypearg{\polybase}{\binop}$, we infer that
there is some type $t_a$ for which

$$\withgenv a : t_a.$$

The case $A[a] = h \mathrel{\binop} A'[a]$ is similar.
\end{proofcase}

This concludes the \atomtyping.
\end{proof}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Special typing
%
\begin{lemma}
\label{lemma:special-typing}
\thmtitle\specialtyping{lemma:special-call-typing}{Special-call typing}
If $\withenv{\genv_r}{S[a] : t_r}$, then there is a type $t_a$ such that
$\withenv{\genv_r}{a : t_a}$.
\end{lemma}

\iftechreport
\begin{proof}
\setgenvtypehat
\setgenvname{\genvorig_r}

We prove this by case analysis on $S$.

%
% Migrate
%
\begin{proofcase}{Migrate}
Suppose $S[a]$ is one of the following forms.

$$
\begin{array}{rcl}
S & ::= & \tailsysmigrate{i}{A}{a_o}{a_{\ms{fun}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailsysmigrate{i}{h_p}{A}{a_{\ms{fun}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailsysmigrate{i}{h_p}{h_o}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailsysmigrate{i}{h_p}{h_o}{h_{\ms{fun}}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}\\
\end{array}
$$

The type judgment for $S$ must use the rule \refmath{Ty-SysMigrate}.

$$\tysysmigrate$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_\ms{ptr}$, then $t_A = \tyrawdata$.
\item If $A = a_\ms{off}$, then $t_A = \tyrawint{32}{\signed}$.
\item If $A = \funname$, then $t_A = \tyfun{\argvec{t\subi}{\polybase}{\varbound}}{\tyvoid}$.
\item If $A = a_i$, then $t_A = t_i$.
\end{itemize}

From the \atomtyping, we can infer that there is some type $t_a$ for
which $\withgenv{a : t_a}$.
\end{proofcase}

%
% Atomic
%
\begin{proofcase}{Atomic}
Suppose $S[a]$ is one of the following forms.

$$
\begin{array}{rcl}
S & ::= & \tailatomic{A}{a_{\ms{const}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomic{\atomfun{v}}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomic{\atomfun{v}}{h_{\ms{const}}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}\\
\end{array}
$$

The type judgment for $S$ must use the rule \refmath{Ty-Atomic}.

$$\tyatomic$$

We have the following case for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = \funname$, then $t_A =
  \tyfun{(\tyrawint{32}{\signed},\cvec{t\subi}{\polybase}{\varbound})}{\tyvoid}$.
\item If $A = a_\ms{const}$, then $t_A = \tyrawint{32}{\signed}$.
\item If $A = a_i$, then $t_A = t_i$.
\end{itemize}

From the \atomtyping, we can infer that there is some type $t_a$ for
which $\withgenv{a : t_a}$.
\end{proofcase}

%
% Rollback
%
\begin{proofcase}{Atomic Rollback}
Suppose $S[a]$ is one of the following forms.

$$
\begin{array}{rcl}
S & ::= & \tailatomicrollback{A}{a_\ms{const}}\\
  &  |  & \tailatomicrollback{h_{\ms{level}}}{A}\\
\end{array}
$$

The type judgment for $S$ must use the rule \refmath{Ty-AtomicRollback}.

$$\tyatomicrollback$$

In both cases $A = a_\ms{const}$ and $A = a_\ms{level}$, we have the judgment $\withgenv{A[a] :
  \tyrawint{32}{\signed}}$.
From the \atomtyping, we can infer that there is some type $t_a$ for
which $\withgenv{a : t_a}$.
\end{proofcase}

\begin{proofcase}{Atomic Commit}
Suppose $S[a]$ is one of the following forms.

$$
\begin{array}{rcl}
S & ::= & \tailatomiccommit{A}{a_\ms{fun}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomiccommit{h_{\ms{level}}}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomiccommit{h_{\ms{level}}}{\atomfun{v}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}\\
\end{array}
$$

The type judgment for $S$ must use the rule \refmath{Ty-AtomicCommit}.

$$\tyatomiccommit$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_\ms{fun}$, then $t_A = \tyfun{\argvec{t\subi}{\polybase}{\varbound}}{\tyvoid}$.
\item If $A = a_\ms{level}$, then $t_A = \tyrawint{32}{\signed}$.
\item If $A = a_i$, then $t_A = t_i$.
\end{itemize}

From the \atomtyping, we can infer that there is some type $t_a$ for
which $\withgenv{a : t_a}$.
\end{proofcase}

This concludes the \specialtyping.
\end{proof}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Allocation
%
\begin{lemma}
\thmtitle\alloctyping{lemma:alloc-typing}{Allocation typing}
If $\withenv{\genv_r}{L[a] : t_r}$, then there is a type $t_a$ such that
$\withenv{\genv_r}{a : t_a}$.
\end{lemma}

\iftechreport
\begin{proof}
\setgenvtypehat
\setgenvname{\genvorig_r}

We prove this by case analysis on $L$.

%
% Tuples
%
\begin{proofcase}{Alloc tuple}
Suppose $L = \alloctuple{\tupleclass}{t}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}$.
The type judgment must use the rule \refmath{Ty-Alloc-Tuple}.

$$\tyalloctuple$$

From the premise $\withgenv a_i : t_i$, we can infer that $\withgenv A[a] : t_i$.  From the
\atomtyping, we can infer that there is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{proofcase}

%
% Unions
%
\begin{proofcase}{Alloc union}
Suppose $L = \allocunion{t}{\tyvar}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}{i}$.  The
type judgment must use the rule \refmath{Ty-Alloc-Union}.

$$\tyallocunion$$

The derivation of the premise must use the store-typing rule \refmath{Ty-StoreUnion} for unions.

$$\tystoreunion$$

From the premise $\withgenv a_i : t_i$, we can infer that $\withgenv A[a] : t_i$.  From the
\atomtyping, we can infer that there is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{proofcase}

%
% Arrays
%
\begin{proofcase}{Alloc array}
Suppose $L$ is one of the following.

$$
\begin{array}{rcl}
L & ::= & \allocarray{t}{A}{a_\ms{init}}\\
  &  |  & \allocarray{t}{h_\ms{size}}{A}
\end{array}
$$

The type judgment must use the rule \refmath{Ty-Alloc-Array}.

$$\tyallocarray$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_\ms{size}$, then $t_A = \indextype$.
\item If $A = a_\ms{init}$, then $t_A = \alttypename$.
\end{itemize}

From the \atomtyping, we can infer that there is some type $t_a$ for
which $\withgenv{a : t_a}$.
\end{proofcase}

%
% Malloc
%
\begin{proofcase}{Malloc}
\setatomname{A[a]}
Suppose $L = \allocmalloc{t}{A}$.  The type judgment must use the rule \refmath{Ty-Alloc-Malloc}.

$$\tyallocmalloc$$

From the premise $\withgenv \atomname : \indextype$, and the \atomtyping, we can infer that there is
some type $t_a$ for which $\withgenv{a : t_a}$.
\end{proofcase}

This concludes the \alloctyping.
\end{proof}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Expression contexts
%
\begin{lemma}
\label{lemma:expr-typing}
\thmtitle\exptypinglemma{lemma:exp-typing}{Expression typing}
If $\withenv{\genv_r}{E[a] : t_r}$, then there is a type $t_a$ such that
$\withenv{\genv_r}{a : t_a}$.
\end{lemma}

\iftechreport
\begin{proof}
\setgenvtypehat
\setgenvname{\genvorig_r}
\settypename{t_r}
We prove this by a case analysis on $E$.

%
% Atoms
%
\begin{proofcase}{LetAtom}
\setatomname{A[a]}

Suppose $E = \letatom{v}{t}{A}{e}$.  The type judgment must use the
\refmath{Ty-LetAtom} rule.

$$\tyletatom$$

From the premise $\withgenv \atomname : t_1$, and the \atomtyping, we
can infer that there is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{proofcase}

%
% External calls.
%
\begin{proofcase}{LetExt}
Suppose $E = \letext{v}{t}{s}{t_s}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{n - 1}}{e}$.
the type judgment must use the \refmath{Ty-LetExt} rule.

$$\tyletext$$

From the premise $\withgenv a_i : u_i$, we can infer that $\withgenv A[a] : u_i$.  From the
\atomtyping, we can infer that there is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{proofcase}

%
% Tailcalls.
%
\begin{proofcase}{TailCall}
Suppose $E$ is one of the following.

$$
\begin{array}{rcl}
E & ::= & \tailcall{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailcall{\atomfun{v}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{n - 1}}
\end{array}
$$

The type judgment must use the \refmath{Ty-TailCall} rule.

$$\tytailcall$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = \funname$, then $t_A = \tyfun{\argvec{\alttypename\subi}{\polybase}{\varbound}}{\tyvoid}$.
\item If $A = a_i$, then $t_A = \alttypename_i$.
\end{itemize}

From the \atomtyping, we can infer that there is some type $t_a$ for
which $\withgenv{a : t_a}$.
\end{proofcase}

%
% Special calls
%
\begin{proofcase}{Special Call}
\settailopname{S}

Suppose $E = \specialcall{S}$.  The type judgment must use the \refmath{Ty-Special-Call} rule.

$$\tyspecialcall$$

From the premise $S : \tyspecial{t}$ and the \specialtyping,
we can infer that there is some type $t_a$ for which
$\withgenv{a : t_a}$.
\end{proofcase}

%
% Match
%
\begin{proofcase}{Match}
\setatomname{A}

Suppose $E = \matchstmt{A}{\lvec{\matchcase{s\subi}{e\subi}}{\polybase}{\varbound}}$.  The type judgment must use the
one of the match rules.

\begin{itemize}
\item If the rule is \refmath{Ty-Match-Int}

$$\tymatchint$$

then we can infer from the premise $\atomname : \tyint$ and the \atomtyping{} that there is some
type $t_a$ for which $\withgenv{a : t_a}$.

\item If the rule is \refmath{Ty-Match-Enum}

$$\tymatchenum$$

then we can infer from the premise $\atomname : \tyenum{i}$ and the \atomtyping{} that there is some
type $t_a$ for which $\withgenv{a : t_a}$.

\item If the rule is \refmath{Ty-Match-RawInt}

$$\tymatchrawint$$

then we can infer from the premise $\atomname : \tyrawint{\pre}{\sign}$ and the \atomtyping{} that there is some type $t_a$ for
which $\withgenv{a : t_a}$.

\item The typing rule \refmath{Ty-Match-Union}

$$\tymatchunion$$

requires that $A = \atomvar{v}$.  We can infer from the declaration
$\vdef{v}{\tyunion{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}}{s_\ms{union}}}$ that $A :
\tyunion{\tyvar}{\cvec{u\subi}{\polybase}{\polybound}}{s_\ms{union}}$.  From the \atomtyping{} that
there is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{itemize}

\end{proofcase}

%
% Allocation
%
\begin{proofcase}{Allocation}
\setallocopname{L}
Suppose $E = \letalloc{v}{L}{e}$.  The type judgment must use the \refmath{Ty-Alloc} rule.

$$\tyletalloc$$

From the premise $\allocop : \tyalloc{\alttypename}$ and the \alloctyping,
we can infer that there is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{proofcase}

%
% Subscripting
%
\begin{proofcase}{Subscripting}
Suppose $E$ is one of the following forms.

$$
\begin{array}{rcl}
E & ::= & \letsubscript{v}{t}{A}{a_2}{e}\\
  &  |  & \letsubscript{v}{t}{h}{A}{e}
\end{array}
$$

The type judgment must use one of the subscript rules.

\begin{itemize}
\item  Suppose the rule is \refmath{Ty-LetSub-RawData}.

$$\tyletsubrawdata$$

We can infer from the premises $a_1 : \tyrawdata$, $a_2 : \indextype$, and the \atomtyping{} that
there is some type $t_a$ for which $\withgenv{a : t_a}$.

\item  Suppose the rule is \refmath{Ty-LetSub-Array}.

$$\tyletsubarray$$

We can infer from the premises $a_1 : \tyarray{t_1}$, $a_2 : \indextype$, and the \atomtyping{} that
there is some type $t_a$ for which $\withgenv{a : t_a}$.

\item  Suppose the rule is \refmath{Ty-LetSub-Tuple}.

$$\tyletsubtuple$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = \atomname$, then $t_A = \tytuple{c}{u_0, \ldots, u_{i-1}, t_1, u_{i+1}, \ldots,
  u_{n-1}}$.
\item If $A = \indexatom{c}{i}$, then $t_A = \tyint$.
\end{itemize}

In both cases, we can infer from the \atomtyping{} that there is some type $t_a$ for which
$\withgenv{a : t_a}$.

\item  Suppose the rule is \refmath{Ty-LetSub-Union}.

$$\tyletsubunion$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_1$, then $t_A = \tyunion{\tyvar}{\cvec{t'\subi}{\polybase}{k}}{\mkset{j}}$.
\item If $A = \indexatom{\normaltuple}{i}$, then $t_A = \tyint$.
\end{itemize}

In both cases, we can infer from the \atomtyping{} that there is some
type $t_a$ for which $\withgenv{a : t_a}$.

\item  Suppose the rule is \refmath{Ty-LetSub-Frame}.

$$\tyletsubframe$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_1$, then $t_A = \tyframe{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}$.  In this case, we can infer
from the \atomtyping{} that there is some type $t_a$ for which
$\withgenv{a : t_a}$.
\item The case $A = \atomlabel{\tyvar}{\framelabel{f}}{\framelabel{sf}}{i_\ms{off}}$, is not
  allowed, because it is not a valid context.
\end{itemize}

\end{itemize}
\end{proofcase}

%
% Assignment
%
\begin{proofcase}{Assignment}
Suppose $E$ is one of the following forms.

$$
\begin{array}{rcl}
E & ::= & \setsubscript{A}{a_2}{t}{a_3}{e}\\
  &  |  & \setsubscript{v}{A}{t}{a_3}{e}\\
  &  |  & \setsubscript{v}{h}{t}{A}{e}\\
\end{array}
$$

The type judgment must use one of the subscript assignment rules.

\begin{itemize}
\item Suppose the rule is \refmath{Ty-SetSub-RawData}.

$$\tysetsubrawdata$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_1$, then $t_A = \tyrawdata$.
\item If $A = a_2$, then $t_A = \indextype$.
\item If $A = a_3$, then $t_A = t_1$.
\end{itemize}

We can infer from the \atomtyping{} that there is some
type $t_a$ for which $\withgenv{a : t_a}$.

\item Suppose the rule is \refmath{Ty-SetSub-Array}.

$$\tysetsubarray$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_1$, then $t_A = \tyarray{\alttypename}$.
\item If $A = a_2$, then $t_A = \indextype$.
\item If $A = a_3$, then $t_A = \alttypename$.
\end{itemize}

We can infer from the \atomtyping{} that there is some
type $t_a$ for which $\withgenv{a : t_a}$.

\item Suppose the rule is \refmath{Ty-SetSub-Tuple}.

\begin{block}
\setarrayname{\atomorig_1}
\setatomname{\atomorig_2}
$$\tysetsubtuple$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = \arrayname$, then $t_A = \tytuple{c}{u_0, \ldots, u_{i-1}, t_1, u_{i+1}, \ldots, u_{n-1}}$.
\item If $A = \atomname$, then $t_A = t_1$.
\item The case $A = \indexatom{c}{i}$ is not allowed because it is not a valid context.
\end{itemize}

For the first two cases, we can infer from the \atomtyping{} that there
is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{block}

\item Suppose the rule is \refmath{Ty-SetSub-Union}.

$$\tysetsubunion$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_1$, then $t_A = \tyunion{\tyvar}{\cvec{t'\subi}{\polybase}{k}}{\mkset{j}}$.
\item If $A = a_3$, then $t_A = t_1$.
\item The case $A = \indexatom{\normaltuple}{i}$ is not allowed because it is not a valid context.
\end{itemize}

For the first two cases, we can infer from the \atomtyping{} that there
is some type $t_a$ for which $\withgenv{a : t_a}$.

\item Suppose the rule is \refmath{Ty-SetSub-Frame}.

$$\tysetsubframe$$

We have the following cases for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = a_1$, then $t_A = \tyframe{\tyvar}{\cvec{t'\subi}{\polybase}{\polybound}}$.
\item If $A = a_3$, then $t_A = t_1$.
\item The case $A = \atomlabel{\tyvar}{\framelabel{f}}{\framelabel{sf}}{i_\ms{off}}$ is not allowed
because it is not a valid context.
\end{itemize}

For the first two cases, we can infer from the \atomtyping{} that there
is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{itemize}
\end{proofcase}

%
% Set global
%
\begin{proofcase}{Global Assignment}
\setatomname{A}
Suppose $E = \setglobal{\xlabel}{t}{A}{e}$.  The proof for type judgment must invoke
the rule \refmath{Ty-SetGlobal}.

$$\tysetglobal$$

From the premise $A : \alttypename$, we can infer from the \atomtyping{}
that there is some type $t_a$ for which $\withgenv{a : t_a}$.
\end{proofcase}

The concludes the \exptypinglemma.
\end{proof}
\fi

The following four lemmas spell out the different substitution lemmas needed for preservation.  In
each case, the argument is by structural induction on an evaluation context $\bullet[a_r]$, using
the typing rules to show that if $\bullet[a_r]$ is well-typed, then so is $a_r$.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ATOM SUBSTITUTION
%
\begin{lemma}
\thmtitle\atomsubstlemma{lemma:atom-subst}{Atom Substitution}
Assume the following:

\begin{itemize}
\item $\withgenv A[a_r] : t$,
\item $\withgenv a_r : u$,
\item $\withgenv a_c : u$.
\end{itemize}

Then $\withgenv A[a_c] : t$.
\end{lemma}

\iftechreport
\begin{proof}
\setgenvtypehat
We prove this by structural induction on $\withgenv A[a_r]$.

\begin{proofcase}{Simple context}
Suppose $A = [ ]$.  Then $A[a_r] = a_r$ and $A[a_c] = a_c$.  By the \uniqueatomtypes, $t = u$.
\end{proofcase}

\begin{proofcase}{Unary operations}
Suppose $A = \mathop{\unop} A'$.  The proof $\withgenv A[a_r] : t$ must use the rule
\refmath{Ty-AtomUnop}, where $t = \unoptyperes{\unop}$.

\begin{block}
\setatomname{A'[a_r]}
$$\tyatomunop$$
\end{block}

By induction, we know $\withgenv A'[a_c] : \unoptypearg{\unop}$, from which we can infer that
$\withgenv \mathop{\unop} A'[a_c] : \unoptyperes{\unop}$.
\end{proofcase}

\begin{proofcase}{Binary operations}
Suppose $A = A' \mathrel{\binop} a$.  The proof $\withgenv A[a_r] : t$ must use the rule
\refmath{Ty-AtomBinop}.

\begin{block}
\setatomnameone{A'[a_r]}
\setatomnametwo{a}
$$\tyatombinop$$
\end{block}

By induction, we know $\withgenv A'[a_c] : \binoptypearg{\polybase}{\binop}$, from which we can infer that
$\withgenv A[a_c] : \binoptyperes{\binop}$.

The argument for the context $A = h \mathrel{\binop} A''$ is similar.
\end{proofcase}

This concludes the proof of the \atomsubstlemma.
\end{proof}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SPECIAL SUBSTITUTION
%
\begin{lemma}
\thmtitle\specialsubst{lemma:special-subst}{SpecialCall Substitution}
Assume all of the following:

\begin{itemize}
\item $\withgenv S[a_r] : \tyspecial{t}$
\item $\withgenv a_r : u$,
\item $\withgenv a_c : u$
\end{itemize}

Then $\withgenv S[a_c] : \tyspecial{t}$.
\end{lemma}

\iftechreport
\begin{proof}
\setgenvtypehat
We prove this by structural induction on $S[a_r]$.

%
% Migration
%
\begin{proofcase}{Migrate}
Suppose $S$ is one of the following.

$$
\begin{array}{rcl}
S & ::= & \tailsysmigrate{i}{A}{a_o}{a_{\ms{fun}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailsysmigrate{i}{h_p}{A}{a_{\ms{fun}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailsysmigrate{i}{h_p}{h_o}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailsysmigrate{i}{h_p}{h_o}{h_{\ms{fun}}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}\\
\end{array}
$$

The type judgment must use the rule \refmath{Ty-SysMigrate}.

$$\tysysmigrate$$

We have the following cases for the type judgment $\withgenv{A[v_r] : t_A}$.

\begin{itemize}
\item If $A = a_\ms{ptr}$, then $t_A = \tyrawdata$.
\item If $A = a_\ms{off}$, then $t_A = \tyrawint{32}{\signed}$.
\item If $A = a_\ms{fun}$, then $t_A = \tyfun{\argvec{\typename\subi}{\polybase}{\varbound}}{\tyvoid}$.
\item If $A = a_i$, then $t_A = t_i$.
\end{itemize}

From the \atomsubstlemma, we can conclude that $\withgenv{A[a_c] :
  t_A}$, from which we can infer that $\withgenv S[a_c] : \tyspecial{t}$.
\end{proofcase}

%
% Atomic
%
\begin{proofcase}{Atomic}
Suppose $S$ is one of the following.

$$
\begin{array}{rcl}
S & ::= & \tailatomic{A}{a_{\ms{const}}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomic{\atomfun{v}}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomic{\atomfun{v}}{h_{\ms{const}}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}
\end{array}
$$

The type judgment must use the rule \refmath{Ty-Atomic}.

$$\tyatomic$$

We have the following case for the type judgment $\withgenv{A[a] : t_A}$.

\begin{itemize}
\item If $A = \funname$, then $t_A =
  \tyfun{(\tyrawint{32}{\signed},\cvec{t\subi}{\polybase}{\varbound})}{\tyvoid}$.
\item If $A = a_\ms{const}$, then $t_A = \tyrawint{32}{\signed}$.
\item If $A = a_i$, then $t_A = t_i$.
\end{itemize}

From the \atomsubstlemma, we can conclude that $\withgenv{A[a_c] :
  t_A}$, from which we can infer that $\withgenv S[h_c] : \tyspecial{t}$.
\end{proofcase}

%
% Rollback
%
\begin{proofcase}{Atomic Rollback}
Suppose $S$ is one of the following.

$$
\begin{array}{rcl}
S & ::= & \tailatomicrollback{A}{a_\ms{const}}\\
  &  |  & \tailatomicrollback{h_{\ms{level}}}{A}\\
\end{array}
$$

The type judgment for $S$ must use the rule \refmath{Ty-AtomicRollback}.

$$\tyatomicrollback$$

In both cases: $A[a_r] = a_\ms{const}$ and $A[a_r] = a_\ms{level}$, we have the judgment $\withgenv{A[a_r] :
  \tyrawint{32}{\signed}}$.

From the \atomsubstlemma, we can conclude that $\withgenv{A[a_c] :
  t_A}$, from which we can infer that $\withgenv S[a_c] : \tyspecial{t}$.
\end{proofcase}

%
% Atomic commit
%
\begin{proofcase}{Atomic Commit}
Suppose $S$ is one of the following forms.

$$
\begin{array}{rcl}
S & ::= & \tailatomiccommit{A}{a_\ms{fun}}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomiccommit{h_{\ms{level}}}{A}{\cvec{a\subi}{\polybase}{\varbound}}\\
  &  |  & \tailatomiccommit{h_{\ms{level}}}{\atomfun{v}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}\\
\end{array}
$$

The type judgment for $S$ must use the rule \refmath{Ty-AtomicCommit}.

$$\tyatomiccommit$$

We have the following cases for the type judgment $\withgenv{A[a_r] : t_A}$.

\begin{itemize}
\item If $A = \funname$, then $t_A = \tyfun{\argvec{t\subi}{\polybase}{\varbound}}{\tyvoid}$.
\item If $A = a_\ms{level}$, then $t_A = \tyrawint{32}{\signed}$.
\item If $A = a_i$, then $t_A = t_i$.
\end{itemize}

From the \atomsubstlemma, we can conclude that $\withgenv{A[a_c] :
  t_A}$, from which we can infer that $\withgenv S[a_c] : \tyspecial{t}$.
\end{proofcase}

This concludes the proof of the \specialsubst.
\end{proof}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Allocation
%
\begin{lemma}
\thmtitle\allocsubst{lemma:alloc-subst}{Allocation substitution}
Assume all of the following.

\begin{itemize}
\item $\withgenv L[a_r] : \tyalloc{t}$,
\item $\withgenv a_r : u$,
\item $\withgenv a_c : u$.
\end{itemize}

Then $\withgenv L[a_c] : \tyalloc{t}$.
\end{lemma}

\iftechreport
\begin{proof}
\setgenvtypehat
We prove this by structural induction on $L$.

%
% Tuples
%
\begin{proofcase}{Alloc tuple}
Suppose $L = \alloctuple{\tupleclass}{t}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}$.
The type judgment must use the rule \refmath{Ty-Alloc-Tuple}.

$$\tyalloctuple$$

From the premise $\withgenv a_i : \alttypename_i$, we can infer that $\withgenv A[a_r] :
\alttypename_i$.  From the \atomsubstlemma, we can conclude that
$\withgenv{A[a_c] : \alttypename_i}$, from which we can infer that $\withgenv L[a_c] : \tyalloc{t}$.
\end{proofcase}

%
% Unions
%
\begin{proofcase}{Alloc union}
Suppose $L = \allocunion{t}{\tyvar}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{\varbound}}{i}$.  The
type judgment must use the rule \refmath{Ty-Alloc-Union}.

$$\tyallocunion$$

The proof of the premise must use the \refmath{Ty-StoreUnion} rule.

$$\tystoreunion$$

From the premise
$\withgenvand{\hvecdef{\alpha\subi}{\Smalltype}{t\subi'}{\polybase}{\polybound}}{a_i :
\alttypename_i}$, we can infer that
$\withgenvand{\hvecdef{\alpha\subi}{\Smalltype}{t\subi'}{\polybase}{\polybound}}{A[a_r] :
\alttypename_i}$.  From the \atomsubstlemma, we can conclude that
$\withgenvand{\hvecdef{\alpha\subi}{\Smalltype}{t\subi'}{\polybase}{\polybound}}{A[a_c] :
\alttypename_i}$, from which we can infer that $\withgenv L[a_c] : \tyalloc{t}$.
\end{proofcase}

%
% Arrays
%
\begin{proofcase}{Alloc array}
Suppose $L$ is one of the following.

$$
\begin{array}{rcl}
L & ::= & \allocarray{t}{A}{a_\ms{init}}\\
  &  |  & \allocarray{t}{h_\ms{size}}{A}
\end{array}
$$

The type judgment must use the rule \refmath{Ty-Alloc-Array}.

$$\tyallocarray$$

We have the following cases for the type judgment $\withgenv{A[a_r] : t_A}$.

\begin{itemize}
\item If $A[a_r] = a_\ms{size}$, then $t_A = \indextype$.
\item If $A[a_r] = a_\ms{init}$, then $t_A = t'$.
\end{itemize}

From the \atomsubstlemma, we can conclude that $\withgenv{A[a_c] :
t_A}$, from which we can infer that $\withgenv L[a_c] : \tyalloc{t}$.
\end{proofcase}

%
% Malloc
%
\begin{proofcase}{Malloc}
\setatomname{A[a_r]}
Suppose $L = \allocmalloc{t}{A}$.  The type judgment must use the rule \refmath{Ty-Alloc-Malloc}.

$$\tyallocmalloc$$

From the premise $\withgenv \atomname : \indextype$, and the \atomsubstlemma, we can conclude that
$\withgenv{A[a_c] : \indextype}$, from which we can infer that $\withgenv L[a_c] : \tyalloc{t}$.
\end{proofcase}

This concludes the proof of \allocsubst.
\end{proof}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% EXPRESSION SUBSTITUTION
%
\begin{lemma}
\thmtitle\expsubstlemma{lemma:exp-subst}{Substitution}
Assume all of the following.

\begin{itemize}
\item $\withgenv{E[a_r] : t}$,
\item $\withgenv{a_r : u}$,
\item $\withgenv{a_c : u}$.
\end{itemize}

Then $\withgenv{E[a_c] : t}$.
\end{lemma}

\iftechreport
\begin{proof}
\setgenvtypehat
We prove this by using a case analysis on the context $E$.

%
% LetAtom
%
\begin{proofcase}{LetAtom}
\setatomname{A[a_r]}

Suppose $E = \letatom{v}{t_1}{A}{e}$.  The typing proof for $E$ must use the rule
\refmath{Ty-LetAtom}.

$$\tyletatom$$

From the \atomsubstlemma, and the premise $\withgenv \atomname : t_1$,
we know $\withgenv A[a_c] : t_1$, and we can infer that $\withgenv \letatom{v}{t_1}{A[a_c]}{e} : t$.
\end{proofcase}

%
% LetExt
%
\begin{proofcase}{LetExt}
Suppose $E = \letext{v_1}{t_1}{s}{t_2}{h_1, \ldots, h_{i - 1}, A, a_{i + 1}, \ldots, a_n}{e}$.  The
proof of typing for $E[a_r]$ must end in the \refmath{Ty-LetExt} rule

$$\tyletext$$

From the \atomsubstlemma, and the premise $\withgenv{A[a_r] : u_i}$,
we know $\withgenv{A[a_c] : u_i}$, and we can infer that $\withgenv E[a_c] : t$.
\end{proofcase}

%
% Tailcall
%
\begin{proofcase}{TailCall}
Suppose $E = \tailcall{A}{\cvec{a\subi}{\polybase}{\varbound}} : t$.  The type proof must use the rule for
\refmath{Ty-TailCall}.

\begin{block}
\setfunname{A[a_r]}
$$\tytailcall$$
\end{block}

From the premise $\withgenv A[a_r] : \tyfun{\argvec{t\subi}{\polybase}{\varbound}}{t}$ we know $\withgenv A[a_r] :
\tyfun{\argvec{t\subi}{\polybase}{\varbound}}{t}$.  From the \atomsubstlemma{} we know
$\withgenv A[a_c] : \tyfun{\argvec{t\subi}{\polybase}{\varbound}}{t}$, and we can infer that $\withgenv E[a_c] : t$.

Similarly, if $E = \tailcall{\atomfun{v}}{\cvec{h\subi}{\polybase}{i - 1}, A, \cvec{a\subi}{i + 1}{n
- 1}}$, then $\withgenv{A[a_r] : \alttypename_i}$.  We can infer that $\withgenv{A[a_c] :
\alttypename_i}$, and conclude that $\withgenv{E[a_c] : t}$.
\end{proofcase}

%
% Special calls
%
\begin{proofcase}{SpecialCall}
\settailopname{S[a_r]}
Suppose $E = \specialcall{S}$.  The type proof must use the rule for \refmath{Ty-Special-Call}.

$$\tyspecialcall$$

From the premise $S[a_r] : \tyspecial{\typename}$ and the \specialsubst, we know $S[a_c] :
\tyspecial{\typename}$, from with we infer that $\withgenv E[a_c] : t$.
\end{proofcase}

%
% Match
%
\begin{proofcase}{Match}
\setatomname{A[a_r]}

Suppose $E = \matchstmt{A}{\lvec{\matchcase{s\subi}{e\subi}}{\polybase}{\varbound}}$.  The typing proof must
use one of the typing inferences for match expressions.  Suppose the proof ends with the rule
for \refmath{Ty-Match-Int}.

$$\tymatchint$$

From the premise $\withgenv A[a_r] : \tyint$, we can infer that $\withgenv A[a_c] : \tyint$, and
conclude that $\withgenv E[a_c] : t$.  The remaining match cases are similar.
\end{proofcase}

%
% Allocation
%
\begin{proofcase}{Alloc}
\setallocopname{L[a_r]} Suppose $E = \letalloc{v}{L}{e}$.  The typing proof must use the
\refmath{Ty-Alloc} rule.

$$\tyletalloc$$

From the premise $\withgenv{L[a_r] : \tyalloc{\alttypename}}$ and the \allocsubst, we can conclude
$\withgenv{L[a_c] : \tyalloc{\alttypename}}$, and infer that $\withgenv{E[a_c] : t}$.
\end{proofcase}

%
% Subscripting
%
\begin{proofcase}{LetSubscript}
Suppose $E$ is one of the following.

$$
\begin{array}{rcl}
E & ::= & \letsubscript{v}{t}{A}{a_2}{e}\\
  &  |  & \letsubscript{v}{t}{h}{A}{e}
\end{array}
$$

The type judgment must end with one of the rules \refmath{Ty-LetSub-RawData},
\refmath{Ty-LetSub-Array}, \refmath{Ty-LetSub-Tuple}, \refmath{Ty-LetSub-Union}, or
\refmath{Ty-LetSub-Frame}.  The cases are similar; we illustrate with the case for arrays.

$$\tyletsubarray$$

We have the following cases for the type judgment $\withgenv{A[a_r] : t_A}$.

\begin{itemize}
\item If $A[a_r] = a_1$, then $t_A = \tyarray{\alttypename}$.
\item If $A[a_r] = a_2$, then $t_A = \indextype$.
\end{itemize}

From the \atomsubstlemma, we know $\withgenv{A[a_c] : t_A}$, and we can
infer that $\withgenv{E[a_c] : t}$.
\end{proofcase}

%
% SetSubscript
%
\begin{proofcase}{SetSubscript}
Suppose $E$ is one of the following.

$$
\begin{array}{rcl}
E & ::= & \setsubscript{A}{a_2}{t}{a_3}{e}\\
  &  |  & \setsubscript{v}{A}{t}{a_3}{e}\\
  &  |  & \setsubscript{v}{h}{t}{A}{e}
\end{array}
$$

The type judgment must end with one of the typing rules \refmath{Ty-SetSub-RawData},
\refmath{Ty-SetSub-Array}, \refmath{Ty-SetSub-Tuple}, \refmath{Ty-SetSub-Union}, or
\refmath{Ty-SetSub-Frame}.  The cases are similar; we illustrate with the case for arrays.

$$\tysetsubarray$$

We have the following cases for the type judgment $\withgenv{A[a_r] : t_A}$.

\begin{itemize}
\item If $A[a_r] = a_1$, then $t_A = \tyarray{\alttypename}$.
\item If $A[a_r] = a_2$, then $t_A = \indextype$.
\item If $A[a_r] = a_3$, then $t_A = \alttypename$.
\end{itemize}

From the \atomsubstlemma, we know $\withgenv{A[a_c] : t_A}$, and we can
infer that $\withgenv{E[a_c] : t}$.
\end{proofcase}

%
% Set Global
%
\begin{proofcase}{SetGlobal}
\setatomname{A[a_r]}
Suppose $E = \setglobal{\xlabel}{t}{A}{e}$.  The proof of typing must end with
\refmath{Ty-SetGlobal}.

$$\tysetglobal$$

From the premise $A[a_r] : \alttypename$ and the \atomsubstlemma, we know
$\withgenv{A[a_c] : \alttypename}$, and we can infer that $\withgenv{E[a_c] : t}$.
\end{proofcase}

\end{proof}
\fi

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Type subst lemma
%

\section{Type substitution}

The final lemma needed for the preservation and progress properties is the type substitution lemma,
which provides the relation between type definitions in the environment and type substitution.  The
proof is a straightforward structural induction on the type $t_r$.

\begin{lemma}
\thmtitle\typesubstlemma{lemma:type-subst}{Type substitution}
The following rule is derivable.

\minferrule\typesubst[Type-Subst]
   {\withgenvtypeand{\hdef{\alpha}{\Type}{u_r}}{\tyequal{t_r[u_r/\alpha]}{t_r}{\Type}}}
   {\withgenvtypeand{\hdef{\alpha}{\Type}{u_r}}{\tyequal{t_r}{t_r}{\Type}}}
\iftechreport
\else
$$\typesubst$$
\fi
\end{lemma}

\iftechreport
\begin{proof}
\shortformfalse

We prove this by structural induction on the type $t_r$.

\begin{proofcase}{Constant types}
If $t_r$ is any of $\tyint$, $\tyenum{i}$, $\tyrawint{\pre}{\sign}$, $\tyfloat{\fpre}$, $\tyrawdata$,
$\typroject{v}{i}$, or a type variable $\beta \neq \alpha$, the substitution has no effect, and the
result follows trivially.
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Variables
%
\begin{proofcase}{Type variables}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t_r = \alpha$.  To prove $\tyequal{u_r}{\alpha}{\Type}$, we apply the
\refmath{Ty-Apply-2} rule (after applying the \refmath{Ty-Sym} rule).

$$
\infer
   {\withenv{(\genv', \hdef{\alpha}{\Type}{u_r}) \xas \genv}{\tyequal{\alpha}{u_r}{\Type}}}
   {\withgenvtype{\tyequal{u_r}{u_r}{\Type}}
    & \withgenvtype{\tyequal{\alpha}{\alpha}{\Type}}}
$$

\nocomment{Emre: Who said $\genv$ was well-formed? We need that
         to apply the \wfcontextvalueslemma. If it well-formed,
         we should state that or make that obvious. (-:}

The premise $\withgenvtype{\tyequal{u_r}{u_r}{\Type}}$
follows from the \wfcontextvalueslemma. Since $t_r = \alpha$,
  it follows that $\withgenvtype{\tyequal{\alpha}{\alpha}{\Type}}$ from the
  premise of \refmath{Type-Subst}.
% follow from the
%  \wfcontext and \wfcontextvalueslemma.
\end{block}
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TUPLES
%
\begin{proofcase}{Tuples}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t_r = \tytuple{\tupleclass}{t_1, \ldots, t_n}$.  The proof that $t_r$ is a well-formed type must
use one of the rules \refmath{WF-ST-TyTuple-Normal} or \refmath{WF-ST-TyTuple-Boxed}.  We illustrate this
proof case with the \refmath{WF-ST-TyTuple-Normal}; the proofs are similar.

\begin{block}
\setgenvtypehat
$$\wfsttytuplenormal$$
\end{block}

From the premise $\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$, we can assume by
induction that
\end{block}
\begin{block}
\renewcommand\eqleft[1]{[u_r/\alpha]}
\renewcommand\eqright[1]{}
$\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$.

We can then re-apply the \refmath{WF-ST-TyTuple-Normal}.

$$\wfsttytuplenormal$$
\end{block}
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ARRAYS
%
\begin{proofcase}{Arrays}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t_r = \tyarray{t}$.  The proof that $t_r$ is well-formed must use the rule \refmath{WF-ST-TyArray}.

\begin{block}
\setgenvtypehat
$$\wfsttyarray$$
\end{block}

From the premise $\tymember{\typename}{\Smalltype}$, we can assume by induction that
\end{block}
\begin{block}
\renewcommand\eqleft[1]{[u_r/\alpha]}
\renewcommand\eqright[1]{}
$\tymember{\typename\supeq}{\Smalltype}$.

We can then re-apply the \refmath{WF-ST-TyArray} rule.

$$\wfsttyarray$$
\end{block}
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Unions
%
\begin{proofcase}{Unions}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t = \tyunion{\tyvar}{t_1, \ldots, t_n}{\intset}$.  The proof that $t_r$ is a well-formed type must
use the rule \refmath{WF-ST-TyUnion}.

\begin{block}
\setgenvtypehat
$$\wfsttyunion$$
\end{block}

From the premise $\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$, we can assume by
induction that
\end{block}
\begin{block}
\renewcommand\eqleft[1]{[u_r/\alpha]}
\renewcommand\eqright[1]{}
$\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$.

We can then re-apply the \refmath{WF-ST-TyUnion} rule.

$$\wfsttyunion$$
\end{block}
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Frames
%
\begin{proofcase}{Frames}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t_r = \tyframe{\tyvar}{t_1,\ldots,t_n}$.  The proof that $t_r$ is a well-formed type must
use the rule \refmath{WF-ST-TyFrame}.

\begin{block}
\setgenvtypehat
$$\wfsttyframe$$
\end{block}

From the premise $\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$, we can assume by
induction that
\end{block}
\begin{block}
\renewcommand\eqleft[1]{[u_r/\alpha]}
\renewcommand\eqright[1]{}
$\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$.

We can then re-apply the \refmath{WF-ST-TyFrame} rule.

$$\wfsttyframe$$
\end{block}
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Type application
%
\begin{proofcase}{Type application}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t_r = \tyapply{\tyvar}{t_1, \ldots, t_n}$.  The proof that $t_r$ is a well-formed type must
use the rule \refmath{Ty-Apply-1}.

\begin{block}
\setgenvtypehat
$$\tyapplyone$$
\end{block}

From the premise $\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$, we can assume by
induction that
%
\end{block}
%
\begin{block}
\renewcommand\eqleft[1]{[u_r/\alpha]}
\renewcommand\eqright[1]{}
%
$\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$.

We can then re-apply the \refmath{Ty-Apply-1} rule.

$$\tyapplyone$$
\end{block}
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Functions
%
\begin{proofcase}{Functions}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t_r = \tyfun{(t_1, \ldots, t_n)}{u}$.  The proof that $t_r$ is well-formed must
end with the rule \refmath{WF-ST-TyFun-Mono}.

\begin{block}
\setgenvtypehat
$$\wfsttyfunmono$$
\end{block}

From the premises $\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$, and
$\tymember{u\supeq}{\Type}$, we can assume by induction that
%
\end{block}
%
\begin{block}
\renewcommand\eqleft[1]{[u_r/\alpha]}
\renewcommand\eqright[1]{}
%
$\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$ and
$\tymember{u\supeq}{\Type}$.
%
We can then re-apply the \refmath{WF-ST-TyFun-Mono} rule.

$$\wfsttyfunmono$$
\end{block}
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Universal quantifier
%
\begin{proofcase}{Universal quantification}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t_r = \tyall{\alpha_1, \ldots, \alpha_n}{t}$.  Then $t_r$ must be a function type
$\tyfun{(t_1, \ldots, t_n)}{u}$, and the proof that $t_r$ is well-formed must
end with the rule \refmath{WF-ST-TyFun-Poly}.

\begin{block}
\setgenvtypehat
$$\wfsttyfunpoly$$
\end{block}

From the premises $\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$, and
$\tymember{u\supeq}{\Type}$, we can assume by induction that
%
\end{block}
%
\begin{block}
\renewcommand\eqleft[1]{[u_r/\alpha]}
\renewcommand\eqright[1]{}
%
$\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$ and
$\tymember{u\supeq}{\Type}$.
%
We can then re-apply the \refmath{WF-ST-TyFun-Poly} rule.

$$\wfsttyfunpoly$$
\end{block}
\end{proofcase}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Existential quantifier
%
\begin{proofcase}{Existential quantification}
\begin{block}
\renewcommand\eqleft[1]{}
\renewcommand\eqright[1]{}

Suppose $t_r = \tyexists{\alpha_1, \ldots, \alpha_n}{t}$.  Then the proof that $t_r$ is well-formed must
end with the rule \refmath{WF-ST-TyExists}.

\begin{block}
\setgenvtypehat
$$\wfsttyexists$$
\end{block}

From the premises $\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$, and
$\tymember{u\supeq}{\Type}$, we can assume by induction that
%
\end{block}
%
\begin{block}
\renewcommand\eqleft[1]{[u_r/\alpha]}
\renewcommand\eqright[1]{}
%
$\lvec{\tymember{\typename\subi\supeq}{\Smalltype}}{\polybase}{\varbound}$.
%
We can then re-apply the \refmath{WF-ST-TyExists} rule.

$$\wfsttyexists$$
\end{block}
\end{proofcase}

This concludes the proof of the \typesubst.
\end{proof}
\fi

% -*-
% Local Variables:
% Mode: LaTeX
% fill-column: 100
% TeX-master: "paper"
% TeX-command-default: "LaTeX/dvips Interactive"
% End:
% -*-
